package codedemo_group5;
import javax.swing.*;
import javax.swing.table.TableColumn;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
/**
 *
 * @author joshs
 */
public class Codedemo_group5 extends JFrame {

    String nextHop;
	private static final long serialVersionUID = 1L;
	private JPanel mainPanel, tablePanel, resultPanel;

	private String[][] tableData = { { "135.46.56.0/22", "Interface 0" }, { "135.46.60.0/22", "Interface 1" },
			{ "192.53.40.0/23", "Router 1" }, { "Default", "Router 2" } };
	private String[] columnNames = { "Address/mask", "Next hop" };
	private JTable table = new JTable(tableData, columnNames);
	private TableColumn column1, column2 = null;
	private JLabel ipText, ipResult, nextHopText, nextHopResult;

	public String getNextHop() {
		return nextHop;
	}

	public String setNextHop(String nextHop) {
		return (this.nextHop = nextHop);
	}

	Codedemo_group5(){
    
    	 int oct1 =Integer.parseInt(JOptionPane.showInputDialog("First Octet: " )); 
    	 int oct2 =Integer.parseInt(JOptionPane.showInputDialog("Second Octet: " ));    
    	 int oct3 =Integer.parseInt(JOptionPane.showInputDialog("Third Octet: " ));    
    	 int oct4 =Integer.parseInt(JOptionPane.showInputDialog("Fourth Octet: " ));    
    	 String ipAddress = (""+oct1+"."+oct2+"."+oct3+"."+oct4+"") ;
        
            if(oct1 == 135 ) {
                if (oct2 == 46) {
                    if (oct3 >= 56 && oct3 <= 59)
                    	setNextHop("Interface 0");
                    else if (oct3 >= 60 && oct3 <= 63)
                        setNextHop("Interface 1");
                    else
                       setNextHop("Router 2");
                }
                else
                     setNextHop("Router 2");

            }
            else if(oct1 == 192){
                if(oct2 == 53){
                    if (oct3 >= 40 && oct3 <= 41)
                        setNextHop("Router 1");
                    else
                        setNextHop("Router 2");
                }
                else
                    setNextHop("Router 2");
            }
            else
                setNextHop("Router 2");
        

        mainPanel = new JPanel(new BorderLayout());

        resultPanel = new JPanel(new GridLayout(2,2));
        resultPanel.setBackground(Color.WHITE);
        ipText = new JLabel("IP Address: ");
        ipText.setHorizontalAlignment(JLabel.HORIZONTAL);
        ipText.setFont(new Font(ipText.getFont().toString(), Font.PLAIN,24));
        resultPanel.add(ipText);
        ipResult = new JLabel("");
        ipResult.setHorizontalAlignment(JLabel.HORIZONTAL);
        ipResult.setForeground(Color.RED);
        ipResult.setFont(new Font(ipText.getFont().toString(), Font.PLAIN,24));
        resultPanel.add(ipResult);
        nextHopText = new JLabel("Next Hop: ");
        nextHopText.setHorizontalAlignment(JLabel.HORIZONTAL);
        nextHopText.setFont(new Font(ipText.getFont().toString(), Font.PLAIN,24));
        resultPanel.add(nextHopText);
        nextHopResult = new JLabel("");
        nextHopResult.setHorizontalAlignment(JLabel.HORIZONTAL);
        nextHopResult.setForeground(Color.BLUE);
        nextHopResult.setFont(new Font(ipText.getFont().toString(), Font.PLAIN,24));
        resultPanel.add(nextHopResult);

        tablePanel = new JPanel(new GridLayout(2,1));
        column1 = table.getColumnModel().getColumn(0);
        column1.setPreferredWidth(500);
        column2 = table.getColumnModel().getColumn(1);
        column2.setPreferredWidth(500);
        table.setRowHeight(40);
        table.setFont(new Font("Serif", Font.BOLD, 20));
        table.setFillsViewportHeight(true);
        tablePanel.add(table.getTableHeader());
        tablePanel.add(table);
        table.getTableHeader().setForeground(Color.BLUE);
        table.getTableHeader().setFont(new Font(ipText.getFont().toString(), Font.PLAIN,24));
        mainPanel.add(tablePanel, BorderLayout.PAGE_END);

        JComboBox ipChoice = new JComboBox();
       
        ipChoice.addItem(ipAddress);
        
        ipChoice.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                ipResult.setText((ipChoice.getSelectedItem().toString()));
                
                    if(ipAddress.equals(ipChoice.getSelectedItem().toString())){
                        nextHopResult.setText(getNextHop());
                    
                }
            }
        });

        mainPanel.add(resultPanel);
        mainPanel.add(ipChoice, BorderLayout.NORTH);
        add(mainPanel);
        repaint();
    }
    public static void main(String[] args) {
        Codedemo_group5 main = new Codedemo_group5();
	main.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	main.setSize(800, 600);
	main.setVisible(true);
	main.setTitle("Demo");
    }
    
}
